=== doc/CMakeLists.txt ===
add_subdirectory(calligra)
if(BUILD_kpresenter)
    add_subdirectory(stage)
endif(BUILD_kpresenter)
if(BUILD_tables)
	add_subdirectory(tables)
endif(BUILD_tables)
add_subdirectory(thesaurus)
INSTALL(FILES   calligra.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
