=== debian/changelog ===
calligra (1:2.3.85-0ubuntu1) precise; urgency=low

  * New upstream beta release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Sun, 11 Dec 2011 18:16:34 +0000

calligra (1:2.3.84-0ubuntu1) precise; urgency=low

  * Ubuntu upload
  * Add build-dep on opengtl-dev, libqtgtl-dev

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 09 Dec 2011 11:57:04 +0000

calligra (1:2.3.84-0r1) UNRELEASED; urgency=low

  * Initial release.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Fri, 20 May 2011 11:45:52 +0200
